#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "mgetty.h"

void exit_usage( int retcode )
{
    fprintf( stderr, "usage: faxin [-d <spool_directory>] [-x <debug>]\n");
    exit( retcode );
}

int main( int argc, char ** argv )
{
char * fax_spool_in = FAX_SPOOL_IN;
char * tty;
int c;

    while ((c = getopt(argc, argv, "x:d:")) != EOF) {
	switch (c) {
	case 'x':
		log_level = atoi(optarg);
		break;
	case 'd':
		fax_spool_in = optarg;
		break;
	case '?':
		exit_usage(2);
		break;
	}
    }

    /* get the name of the tty stdin is connected to (jcp) */
    tty = ttyname(STDIN_FILENO);

    if ( tty == NULL || *tty == '\0' ) tty = "unknown";

    /* if present, remove the leading "/dev/" prefix */
    if ( strncmp( tty, "/dev/", 5 ) == 0 ) tty += 5;

    /* construct the log path string */
    sprintf( log_path, LOG_PATH, tty );


    /* receive the fax */
    faxrec( fax_spool_in );
    return 0;
}
